---
title: Create a new role
slug: api-documentation/create-a-new-role
docTags: 
createdAt: 2026-08-27T17:06:32.549Z
---

{
  "id": "b1ldOjDDa0G_KlwHootJi",
  "type": "api-oas-v2",
  "data": {
    "method": "POST",
    "url": "https://api.upstartcommerce.com/profile-permissions/roles",
    "servers": [
      {
        "url": "https://api.upstartcommerce.com/profile-permissions/roles",
        "description": "Production"
      }
    ],
    "name": "Create a new role",
    "description": "<p>Creates a new role with optional initial permissions.</p>\n<p><strong>Required Permission:</strong> <code>profile-permissions.roles.write</code></p>",
    "contentType": "application/json",
    "request": {
      "pathParameters": [],
      "headerParameters": [
        {
          "name": "accept",
          "type": "string",
          "kind": "optional",
          "description": "Generated from available response content types",
          "enum": [
            "application/json"
          ],
          "default": "application/json"
        }
      ],
      "queryParameters": [],
      "bodyDataParameters": [
        {
          "kind": "required",
          "name": "body",
          "type": "object",
          "description": "The role to create.",
          "customType": "CreateRoleRequest",
          "schema": [
            {
              "name": "name",
              "kind": "required",
              "type": "string",
              "description": "<p>Role name (must be unique within scope/tenant/site)</p>",
              "example": "warehouse-manager",
              "minLength": 1,
              "maxLength": 100
            },
            {
              "name": "scope",
              "kind": "required",
              "type": "string<GLOBAL | TENANT | SITE>",
              "description": "<p>Role scope - GLOBAL for templates, TENANT for tenant-specific roles, SITE for site-specific roles</p>",
              "enum": [
                "GLOBAL",
                "TENANT",
                "SITE"
              ]
            },
            {
              "name": "tenantId",
              "kind": "optional",
              "type": "string",
              "description": "<p>Tenant ID (required when scope is TENANT or SITE)</p>"
            },
            {
              "name": "siteId",
              "kind": "optional",
              "type": "string",
              "description": "<p>Site ID (required when scope is SITE)</p>"
            },
            {
              "name": "roleDescription",
              "kind": "optional",
              "type": "string",
              "description": "<p>Human-readable description</p>",
              "maxLength": 500
            },
            {
              "name": "roleType",
              "kind": "required",
              "type": "string<Management | Consumer>",
              "description": "Role type",
              "enum": [
                "Management",
                "Consumer"
              ]
            },
            {
              "name": "permissions",
              "kind": "optional",
              "type": "array",
              "description": "Initial permissions to grant to this role",
              "example": "[\"inventory.read\",\"inventory.write\"]",
              "itemType": "string",
              "customType": "string[]",
              "itemExample": "",
              "itemDefault": ""
            }
          ],
          "modelRef": "#/components/schemas/CreateRoleRequest",
          "isExpanded": true
        }
      ],
      "formDataParameters": [],
      "oAuthParameters": [
        {
          "id": "bearerAuth",
          "name": "bearerAuth",
          "kind": "optional",
          "type": "http",
          "description": "<p>JWT token from authentication service.</p>\n<p>The token contains:</p>\n<ul>\n<li>sub: User ID</li>\n<li>tenant: Tenant ID (used for all operations)</li>\n<li>roles: Array of role IDs</li>\n<li>type: \"management\" or \"consumer\"</li>\n</ul>\n<p>Alternatively, tenant can be specified via X-Tenant-Id header.</p>",
          "scheme": "bearer"
        }
      ],
      "cookieParameters": []
    },
    "responses": [
      {
        "statusCode": "201",
        "description": "Role created successfully",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "<p>A role definition - its scope (GLOBAL template, TENANT or SITE) and type (Management or Consumer) - without the permissions it grants.</p>",
            "customType": "Role",
            "schema": [
              {
                "name": "id",
                "kind": "required",
                "type": "string",
                "description": "Role identifier"
              },
              {
                "name": "name",
                "kind": "required",
                "type": "string",
                "description": "<p>Role name (unique within scope/tenant/site)</p>",
                "example": "operator"
              },
              {
                "name": "scope",
                "kind": "required",
                "type": "string<GLOBAL | TENANT | SITE>",
                "description": "<p>Role scope - GLOBAL for templates, TENANT for tenant-specific roles, SITE for site-specific roles</p>",
                "enum": [
                  "GLOBAL",
                  "TENANT",
                  "SITE"
                ]
              },
              {
                "name": "tenantId",
                "kind": "optional",
                "type": "string",
                "description": "<p>Tenant ID (required when scope is TENANT or SITE)</p>"
              },
              {
                "name": "siteId",
                "kind": "optional",
                "type": "string",
                "description": "<p>Site ID (required when scope is SITE)</p>"
              },
              {
                "name": "roleDescription",
                "kind": "optional",
                "type": "string",
                "description": "<p>Human-readable description</p>"
              },
              {
                "name": "roleType",
                "kind": "required",
                "type": "string<Management | Consumer>",
                "description": "<p>Role type - Management for admin users, Consumer for customers</p>",
                "enum": [
                  "Management",
                  "Consumer"
                ]
              },
              {
                "name": "createdAt",
                "kind": "required",
                "type": "string<date-time>",
                "description": "",
                "format": "date-time"
              },
              {
                "name": "updatedAt",
                "kind": "required",
                "type": "string<date-time>",
                "description": "",
                "format": "date-time"
              }
            ],
            "modelRef": "#/components/schemas/Role",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "400",
        "description": "Invalid request parameters",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "<p>Error payload identifying the failure by error code and message, with optional detail.</p>",
            "customType": "ErrorResponse",
            "schema": [
              {
                "name": "error",
                "kind": "required",
                "type": "string<bad_request | unauthorized | forbidden | not_found | conflict | internal_error>",
                "description": "Error code",
                "example": "not_found",
                "enum": [
                  "bad_request",
                  "unauthorized",
                  "forbidden",
                  "not_found",
                  "conflict",
                  "internal_error"
                ]
              },
              {
                "name": "message",
                "kind": "required",
                "type": "string",
                "description": "<p>Human-readable error message</p>",
                "example": "Role not found"
              },
              {
                "name": "details",
                "kind": "optional",
                "type": "map",
                "description": "Additional error details",
                "example": "",
                "customType": "map<string, string>",
                "schema": []
              }
            ],
            "modelRef": "#/components/schemas/ErrorResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "401",
        "description": "Missing or invalid authentication token",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "<p>Error payload identifying the failure by error code and message, with optional detail.</p>",
            "customType": "ErrorResponse",
            "schema": [
              {
                "name": "error",
                "kind": "required",
                "type": "string<bad_request | unauthorized | forbidden | not_found | conflict | internal_error>",
                "description": "Error code",
                "example": "not_found",
                "enum": [
                  "bad_request",
                  "unauthorized",
                  "forbidden",
                  "not_found",
                  "conflict",
                  "internal_error"
                ]
              },
              {
                "name": "message",
                "kind": "required",
                "type": "string",
                "description": "<p>Human-readable error message</p>",
                "example": "Role not found"
              },
              {
                "name": "details",
                "kind": "optional",
                "type": "map",
                "description": "Additional error details",
                "example": "",
                "customType": "map<string, string>",
                "schema": []
              }
            ],
            "modelRef": "#/components/schemas/ErrorResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "409",
        "description": "Role with this name already exists",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "<p>Error payload identifying the failure by error code and message, with optional detail.</p>",
            "customType": "ErrorResponse",
            "schema": [
              {
                "name": "error",
                "kind": "required",
                "type": "string<bad_request | unauthorized | forbidden | not_found | conflict | internal_error>",
                "description": "Error code",
                "example": "not_found",
                "enum": [
                  "bad_request",
                  "unauthorized",
                  "forbidden",
                  "not_found",
                  "conflict",
                  "internal_error"
                ]
              },
              {
                "name": "message",
                "kind": "required",
                "type": "string",
                "description": "<p>Human-readable error message</p>",
                "example": "Role not found"
              },
              {
                "name": "details",
                "kind": "optional",
                "type": "map",
                "description": "Additional error details",
                "example": "",
                "customType": "map<string, string>",
                "schema": []
              }
            ],
            "modelRef": "#/components/schemas/ErrorResponse",
            "isExpanded": true
          }
        ]
      },
      {
        "statusCode": "500",
        "description": "Internal server error",
        "jsonExample": "",
        "isExpanded": true,
        "schema": [
          {
            "kind": "optional",
            "type": "object",
            "description": "<p>Error payload identifying the failure by error code and message, with optional detail.</p>",
            "customType": "ErrorResponse",
            "schema": [
              {
                "name": "error",
                "kind": "required",
                "type": "string<bad_request | unauthorized | forbidden | not_found | conflict | internal_error>",
                "description": "Error code",
                "example": "not_found",
                "enum": [
                  "bad_request",
                  "unauthorized",
                  "forbidden",
                  "not_found",
                  "conflict",
                  "internal_error"
                ]
              },
              {
                "name": "message",
                "kind": "required",
                "type": "string",
                "description": "<p>Human-readable error message</p>",
                "example": "Role not found"
              },
              {
                "name": "details",
                "kind": "optional",
                "type": "map",
                "description": "Additional error details",
                "example": "",
                "customType": "map<string, string>",
                "schema": []
              }
            ],
            "modelRef": "#/components/schemas/ErrorResponse",
            "isExpanded": true
          }
        ]
      }
    ],
    "hasXCodeSamples": false,
    "examples": {
      "languages": [
        {
          "id": "cizki9JqNNrOApZsHL2Za",
          "language": "curl",
          "label": "cURL",
          "code": "curl --request POST \\\n     --url https://api.upstartcommerce.com/profile-permissions/roles \\\n     --header 'accept: application/json' \\\n     --header 'content-type: application/json' \\\n     --data '{\n     \"name\": \"warehouse-manager\",\n     \"scope\": \"\",\n     \"roleType\": \"\"\n     }'"
        },
        {
          "id": "kaz7ZoBVVgPFPfv8dVwmm",
          "language": "javascript",
          "label": "javascript",
          "code": "var myHeaders = new Headers();\nmyHeaders.append(\"accept\", \"application/json\");\nmyHeaders.append(\"content-type\", \"application/json\");\n\nvar raw = JSON.stringify({\n   \"name\": \"warehouse-manager\",\n   \"scope\": \"\",\n   \"roleType\": \"\"\n});\n\nvar requestOptions = {\n   method: 'POST',\n   headers: myHeaders,\n   body: raw,\n   redirect: 'follow'\n};\n\nfetch(\"https://api.upstartcommerce.com/profile-permissions/roles\", requestOptions)\n   .then(response => response.text())\n   .then(result => console.log(result))\n   .catch(error => console.log('error', error));"
        },
        {
          "id": "eiGmTEGbyyXjx_SviV7ff",
          "language": "ruby",
          "label": "Ruby",
          "code": "require \"uri\"\nrequire \"json\"\nrequire \"net/http\"\n\nurl = URI(\"https://api.upstartcommerce.com/profile-permissions/roles\")\n\nhttps = Net::HTTP.new(url.host, url.port)\nhttps.use_ssl = true\n\nrequest = Net::HTTP::Post.new(url)\nrequest[\"accept\"] = \"application/json\"\nrequest[\"content-type\"] = \"application/json\"\nrequest.body = JSON.dump({\n   \"name\": \"warehouse-manager\",\n   \"scope\": \"\",\n   \"roleType\": \"\"\n})\n\nresponse = https.request(request)\nputs response.read_body\n"
        },
        {
          "id": "up4ed55ql_f9gT19N5ATg",
          "language": "python",
          "label": "Python",
          "code": "import requests\nimport json\n\nurl = \"https://api.upstartcommerce.com/profile-permissions/roles\"\n\npayload = json.dumps({\n   \"name\": \"warehouse-manager\",\n   \"scope\": \"\",\n   \"roleType\": \"\"\n})\nheaders = {\n   'accept': 'application/json',\n   'content-type': 'application/json'\n}\n\nresponse = requests.request(\"POST\", url, headers=headers, data=payload)\n\nprint(response.text)\n"
        }
      ],
      "selectedLanguageId": "cizki9JqNNrOApZsHL2Za"
    },
    "results": {
      "languages": [
        {
          "id": "BCAE-liZxSQSxY-CwWpiU",
          "language": "201",
          "code": "// Role created successfully\n{\n  \"id\": \"\",\n  \"name\": \"operator\",\n  \"scope\": \"\",\n  \"tenantId\": \"\",\n  \"siteId\": \"\",\n  \"roleDescription\": \"\",\n  \"roleType\": \"\",\n  \"createdAt\": \"\",\n  \"updatedAt\": \"\"\n}"
        },
        {
          "id": "9zhqoiytpQTPBbO1OQaRh",
          "language": "400",
          "code": "// Invalid request parameters\n{\n  \"error\": \"not_found\",\n  \"message\": \"Role not found\",\n  \"details\": \"\"\n}"
        },
        {
          "id": "J-iypW_L1za3_a1SQjw41",
          "language": "401",
          "code": "// Missing or invalid authentication token\n{\n  \"error\": \"not_found\",\n  \"message\": \"Role not found\",\n  \"details\": \"\"\n}"
        },
        {
          "id": "FsPlup5i8CQbTz6E7E8yq",
          "language": "409",
          "code": "// Role with this name already exists\n{\n  \"error\": \"not_found\",\n  \"message\": \"Role not found\",\n  \"details\": \"\"\n}"
        },
        {
          "id": "vS-27xQl-Kd2pbYNoKM8d",
          "language": "500",
          "code": "// Internal server error\n{\n  \"error\": \"not_found\",\n  \"message\": \"Role not found\",\n  \"details\": \"\"\n}"
        }
      ],
      "selectedLanguageId": "BCAE-liZxSQSxY-CwWpiU"
    }
  },
  "children": [
    {
      "text": ""
    }
  ]
}